package net.ecoop.android.viewlifecycle;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;

public class MainActivity extends Activity {

	private Handler mHandler;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		Logger.log(this, "begin");
		super.onCreate(savedInstanceState);
		Logger.log(this, "initialized");
		setContentView(R.layout.activity_main);
		mHandler = new Handler();
		findViewById(R.id.buttonRemove).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View v) {
						mHandler.post(new Runnable() {

							@Override
							public void run() {
								((ViewGroup) findViewById(R.id.contentView))
										.removeAllViews();
							}
						});
					}
				});
		findViewById(R.id.buttonAddWithJava).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View v) {
						mHandler.post(new Runnable() {

							@Override
							public void run() {
								View view = new CustomView(MainActivity.this);
								Logger.log(MainActivity.this, "call addView");
								((ViewGroup) findViewById(R.id.contentView))
										.addView(view);
							}
						});
					}
				});
		findViewById(R.id.buttonAddWithXml).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View v) {
						mHandler.post(new Runnable() {

							@Override
							public void run() {
								View view = getLayoutInflater().inflate(
										R.layout.custom_view, null);
								Logger.log(MainActivity.this, "call addView");
								((ViewGroup) findViewById(R.id.contentView))
										.addView(view);
							}
						});
					}
				});
		findViewById(R.id.buttonReplace).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View v) {
						mHandler.post(new Runnable() {
							@Override
							public void run() {
								setContentView(R.layout.activity_main2);
							}
						});
					}
				});
		findViewById(R.id.buttonRequestLayout).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View v) {
						mHandler.post(new Runnable() {

							@Override
							public void run() {
								ViewGroup group = ((ViewGroup) findViewById(R.id.contentView));
								int max = group.getChildCount();
								for (int i = 0; i < max; i++) {
									group.getChildAt(i).requestLayout();
								}

							}
						});
					}
				});
		findViewById(R.id.buttonForceLayout).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View v) {
						mHandler.post(new Runnable() {

							@Override
							public void run() {
								ViewGroup group = ((ViewGroup) findViewById(R.id.contentView));
								int max = group.getChildCount();
								for (int i = 0; i < max; i++) {
									group.getChildAt(i).forceLayout();
								}

							}
						});
					}
				});
		findViewById(R.id.buttonInvalidate).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View v) {
						mHandler.post(new Runnable() {

							@Override
							public void run() {
								ViewGroup group = ((ViewGroup) findViewById(R.id.contentView));
								int max = group.getChildCount();
								for (int i = 0; i < max; i++) {
									group.getChildAt(i).invalidate();
								}

							}
						});
					}
				});
		Logger.log(this, "end");
	}

	@Override
	protected void onRestart() {
		Logger.log(this, "begin");
		super.onRestart();
		Logger.log(this, "end");
	}

	@Override
	protected void onResume() {
		Logger.log(this, "begin");
		super.onResume();
		Logger.log(this, "end");
	}

	@Override
	protected void onPause() {
		Logger.log(this, "begin");
		super.onPause();
		Logger.log(this, "end");
	}

	@Override
	protected void onStop() {
		Logger.log(this, "begin");
		super.onStop();
		Logger.log(this, "end");
	}

	@Override
	protected void onDestroy() {
		Logger.log(this, "begin");
		super.onDestroy();
		Logger.log(this, "end");
	}

}
